<?php

/**
 * @version    2.2.12
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

jimport('joomla.language.helper');

class plgContentMyMapLocations extends JPlugin {

    public function onContentPrepare($context, &$content, &$params, $limitstart) {


        // Get data to replace
        $tag = 'mymaplocation';

        $app = JFactory::getApplication();
        $db = JFactory::getDBO();
        $option = JRequest::getVar('option');
        $task = JRequest::getVar('task');
        $width = null;
        $height = null;
        if ($option == 'com_content' && $task == 'edit')
            return true;
        if (strpos($content->text, '{' . $tag . ' ') === false)
            return true;

        if (!$this->checkComponent())
            return true;
        $pattern = '#\{' . $tag . ' (.*?)}#i';
        if (preg_match_all($pattern, $content->text, $matches)) {

            $lang = JFactory::getLanguage();
            $lang->load('com_mymaplocations', JPATH_SITE);
            $mapid = "";
            $height = "";
            $width = "";
            $zoom = "";
            $type = "";
            foreach ($matches[0] as $i => $match) {
                $datas = explode(" ", $matches[1][$i]);
                foreach ($datas as $data) {
                    if (preg_match('|id=|', $data)) {
                        $id = (str_ireplace('id=', '', $data));
                        $mapid = explode(",", $id);
                        JArrayHelper::toInteger($mapid);
                    } else if (preg_match('|height=|', $data)) {
                        $height = (str_ireplace('height=', '', $data));
                    } else if (preg_match('|width=|', $data)) {
                        $width = (str_ireplace('width=', '', $data));
                    } else if (preg_match('|zoom=|', $data)) {
                        $zoom = (str_ireplace('zoom=', '', $data));
                    } else if (preg_match('|type=|', $data)) {
                        $type = (str_ireplace('type=', '', $data));
                    }
                }
                // Create a new query object.
                $query = $db->getQuery(true);
                $query->select('*');
                $query->from('#__mymaplocations_location');
                $query->where('id IN (' . implode(',', $mapid) . ')');
                $db->setQuery($query);
                $result = $db->loadObjectList();
                $content->text = str_replace($matches[0][$i], MyMapLocationsHelper::CreateMap($result, $width, $height, $zoom, $type), $content->text);
            }
        }
    }

    function checkComponent() {
        if (class_exists('MyMapLocationsHelper'))
            return true;

        $helper = JPATH_SITE . '/components/com_mymaplocations/helpers/mymaplocations.php';
        if (file_exists($helper)) {
            require_once($helper);
            return true;
        }

        return false;
    }

}
