<?php

/**
 * @version    2.2.12
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * ****@author      joomunited - contact@joomunited.com
 */
// No direct access
defined('_JEXEC') or die;

/**
 * MyMaplocations helper.
 */
class MyMaplocationsHelper {

    /**
     * Configure the Linkbar.
     */
    public static function addSubmenu($vName = '') {
        JHtmlSidebar::addEntry(
                JText::_('COM_MYMAPLOCATIONS_TITLE_STORES'), 'index.php?option=com_mymaplocations&view=locations', $vName == 'locations'
        );
        JHtmlSidebar::addEntry(
                JText::_('JCATEGORY'), 'index.php?option=com_categories&extension=com_mymaplocations', $vName == 'categories'
        );
        JHtmlSidebar::addEntry(
                JText::_('Import'), 'index.php?option=com_mymaplocations&view=locations&view=import', $vName == 'import'
        );


        if ($vName == 'categories') {
            JToolBarHelper::title(
                    JText::sprintf('COM_CATEGORIES_CATEGORIES_TITLE', JText::_('com_mymaplocations')), 'mymaplocations-categories');
        }
    }

    /**
     * Gets a list of the actions that can be performed.
     *
     * @return	JObject
     * @since	1.6
     */
    public static function getActions() {
        $user = JFactory::getUser();
        $result = new JObject;

        $assetName = 'com_mymaplocations';

        $actions = array(
            'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
        );

        foreach ($actions as $action) {
            $result->set($action, $user->authorise($action, $assetName));
        }

        return $result;
    }
    
    public static function getLastExtensionVersion($extension=null){
        if($extension===null){
            $extension = JFactory::getApplication()->input->getString('option', '');
        }
        if (ini_get("allow_url_fopen") == 1) {
            $content = file_get_contents('http://www.joomunited.com/UPDATE-INFO/updates.json');
        }else{
           
            return false;
        }
        $json = json_decode($content);
        
        return $json->extensions->$extension->version;       
   }
   
   /**
    * Return the extension version
    * @param string $extension
    * @param string $type
    * @return string version or false
    */
   public static function getExtensionVersion($extension=null,$type=''){
        if($extension===null){
             $extension = JFactory::getApplication()->input->getString('option', '');
        }
        $db = JFactory::getDbo();
        $query = 'SELECT manifest_cache FROM #__extensions WHERE element='.$db->quote($extension);

        if($type!=''){
            $query.=' AND type='.$db->quote($type);
        }
        $db->setQuery($query);
        if($db->query()){
            $manifest = $db->loadResult();
            $json = json_decode($manifest);
            if(property_exists($json, 'version')){
                return $json->version;
            }
        }
        return false;
   }
}
