<?php

/**
 * @version    2.2.12
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
// No direct access
defined('_JEXEC') or die('Restricted access');

//Maybe it is possible to set this within the xml file note by Max Milbers
@ini_set('memory_limit', '32M');
@ini_set('max_execution_time', '120');

jimport('joomla.application.component.model');

defined('DS') or define('DS', DIRECTORY_SEPARATOR);

jimport('joomla.installer.installer');

/**
 * MML custom installer class
 */
class com_mymaplocationsInstallerScript {

    public function install($parent) {
        $installer = method_exists($parent, 'getParent') ? $parent->getParent() : $parent->parent;
        $dst = JPATH_ROOT . DS . 'images' . DS . 'icons';
        $src = $installer->getPath('source') . DS . 'images' . DS . 'icons';
        $this->recurse_copy($src, $dst);
    }

    function postflight($type, $parent) {
        // $parent is the class calling this method
        // $type is the type of change (install, update or discover_install)

        if ($type == 'install') {
            $basePath = JPATH_ADMINISTRATOR . '/components/com_categories';
            require_once $basePath . '/models/category.php';
            $config = array('table_path' => $basePath . '/tables');
            $catmodel = new CategoriesModelCategory($config);
            $catData = array('id' => 0, 'parent_id' => 0, 'level' => 1, 'path' => 'locationlocator', 'extension' => 'com_mymaplocations'
                , 'title' => 'my category', 'alias' => 'my-category', 'description' => '', 'published' => 1, 'language' => '*');
            $status = @$catmodel->save($catData);

            if (!$status) {
                JError::raiseWarning(500, JText::_('Unable to create default content category!'));
            }
        }
        $db = JFactory::getDBO();
        $fields = $db->getTableColumns('#__mymaplocations_location');

        if (!array_key_exists('component', $fields)) {

            $query = "ALTER TABLE #__mymaplocations_location ADD `maptype` varchar(255) NOT NULL  AFTER `description`";
            $db->setQuery($query);
            $db->query();
            $query = "ALTER TABLE #__mymaplocations_location ADD `extra_id` int(11) NOT NULL AFTER `description`";
            $db->setQuery($query);
            $db->query();
            $query = "ALTER TABLE #__mymaplocations_location ADD `component` varchar(255) NOT NULL AFTER `description`";
            $db->setQuery($query);
            $db->query();
        }
        if (!array_key_exists('phone', $fields)) {
            $query = "ALTER TABLE #__mymaplocations_location ADD `phone` varchar(255) NOT NULL  AFTER `description`";
            $db->setQuery($query);
            $db->query();
        }
        if (!array_key_exists('hours', $fields)) {
            $query = "ALTER TABLE #__mymaplocations_location ADD `hours` text NOT NULL  AFTER `description`";
            $db->setQuery($query);
            $db->query();
        }
        if (!array_key_exists('contactlink', $fields)) {
            $query = "ALTER TABLE #__mymaplocations_location ADD `contactlink` varchar(255) NOT NULL  AFTER `description`";
            $db->setQuery($query);
            $db->query();
        }
        if (!array_key_exists('metadesc', $fields)) {
            $query = "ALTER TABLE #__mymaplocations_location ADD `metadesc` text NOT NULL  AFTER `description`";
            $db->setQuery($query);
            $db->query();
        }
        if (!array_key_exists('metakey', $fields)) {
            $query = "ALTER TABLE #__mymaplocations_location ADD `metakey` text NOT NULL  AFTER `description`";
            $db->setQuery($query);
            $db->query();
        }
        $manifest = $parent->get('manifest');
          $extensions = $manifest->extensions;
           JLoader::register('InstallerHelper', JPATH_ADMINISTRATOR . '/components/com_mymaplocations/helpers/installer.php');
           foreach($extensions->children() as $extension){
                        $folder = $extension->attributes()->folder;
                        $enable = $extension->attributes()->enable;
                        if(InstallerHelper::install(JPATH_ADMINISTRATOR.'/components/com_mymaplocations/extensions/'.$folder,$enable)){
    //                        JFile::delete(JPATH_ADMINISTRATOR.'/components/com_sponsorshipreward/extensions/'.$folder);
                            echo '<img src="'. JURI::root().'/components/com_mymaplocations/assets/images/tick.png" />'.JText::sprintf($folder).' : '.JText::sprintf('OK','').'<br/>';
                        }else{
                            echo '<img src="'. JURI::root().'/components/com_mymaplocations/assets/images/exclamation.png" />'.JText::sprintf($folder).' : '.JText::sprintf('Not OK','').'<br/>';
                        }
                }


    }

    function createIndexFolder($path) {
        if (!class_exists('JFile'))
            require(JPATH_ROOT . DS . 'joomla' . DS . 'filesystem' . DS . 'file.php');
        if (JFolder::create($path)) {
            if (!JFile::exists($path . DS . 'index.html')) {
                JFile::copy(JPATH_ROOT . DS . 'components' . DS . 'index.html', $path . DS . 'index.html');
            }
            return true;
        }
        return false;
    }

    /**
     * copy all $src to $dst folder and remove it
     *
     * ***@author Max Milbers
     * @param String $src path
     * @param String $dst path
     * @param String $type modules, plugins, languageBE, languageFE
     */
    private function recurse_copy($src, $dst) {

        $dir = opendir($src);
        $this->createIndexFolder($dst);

        if (is_resource($dir)) {
            while (false !== ( $file = readdir($dir))) {
                if (( $file != '.' ) && ( $file != '..' )) {
                    if (is_dir($src . DS . $file)) {
                        $this->recurse_copy($src . DS . $file, $dst . DS . $file);
                    } else {
                        if (JFile::exists($dst . DS . $file)) {
                            if (!JFile::delete($dst . DS . $file)) {
                                $app = JFactory::getApplication();
                                $app->enqueueMessage('Couldnt delete ' . $dst . DS . $file);
                            }
                        }
                        if (!JFile::move($src . DS . $file, $dst . DS . $file)) {
                            $app = JFactory::getApplication();
                            $app->enqueueMessage('Couldnt move ' . $src . DS . $file . ' to ' . $dst . DS . $file);
                        }
                    }
                }
            }
            closedir($dir);
            if (is_dir($src))
                JFolder::delete($src);
        } else {
            $app = JFactory::getApplication();
            $app->enqueueMessage('Couldnt read dir ' . $dir . ' source ' . $src);
        }
    }
    function uninstall($parent)
        {
        $db = JFactory::getDBO();
        $status = new stdClass;
        $status->modules = array();
        $status->plugins = array();
        $manifest = $parent->get('manifest');
        $extensions = $manifest->extensions;
        
        foreach($extensions->children() as $plugin)
        {
            $group = (string)$plugin->attributes()->group;
	    $element=(string)$plugin->attributes()->element;
	    $type=(string)$plugin->attributes()->type;
            $query = "SELECT `extension_id` FROM #__extensions WHERE element = ".$db->Quote($element)." AND folder=".$db->Quote($group);
            $db->setQuery($query);
            $extensions = $db->loadColumn();
	    if (count($extensions))
            {
                foreach ($extensions as $id)
                {
                    $installer = new JInstaller;
                    $result = $installer->uninstall($type, $id);
                }
            
            }
            
        }
        }
    

}

