    <?php
    
    /**
     * @version    2.2.12
     * @package     com_mymaplocations
     * @copyright   JoomUnited (C) 2011. All rights reserved.
     * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
     * ****@author      joomunited - contact@joomunited.com
     */
    defined('_JEXEC') or die;
    
    abstract class MyMaplocationsHelper {
        
        static $result=0;
        static $bresult=0;
        public static function loadGoogleJs()
        {
            if(self::$result==0)
            {
                   $params = JComponentHelper::getParams('com_mymaplocations');
                $googleapi=$params->get('googleapi',null);
                self::$result=self::$result+1;
                          $doc = JFactory::getDocument();
                 $url='//maps.googleapis.com/maps/api/js?v=3.exp&amp;sensor=false&amp;libraries=places';
                if($googleapi)
                {
                $url.='&amp;key='.$googleapi;    
                }
                $url.=MyMaplocationsHelper::addLocalization();
                $doc ->addScript($url);
                return;
    
            }
            return '';
        }
          public static function loadBingJs()
        {
            if(self::$bresult==0)
            {
                $doc = JFactory::getDocument();
                $url='//ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0';
                $doc ->addScript($url);
                self::$bresult=self::$bresult+1;
                return;
    
            }
            return '';
        }
    
        public static function CreateMap($items, $width = null, $height = null, $zoom = null, $type = null) {
            $doc = JFactory::getDocument();
            MyMaplocationsHelper::loadLanguage();
            $params = JComponentHelper::getParams('com_mymaplocations');
            if (empty($zoom)) {
                $zoom = JRequest::getVar('viewzoom', ($params->get('viewzoom', 9)));
            }
             $autozoom=$params->get('autozoom',1);
            $bingkey = $params->get('bingapi');
            $bootstrap = $params->get('bootstrap', 1);
            $globalcolor = $params->get('globalcolor', '#2980b9');
            $markercolor = $params->get('markercolor', '#000000');
            if ($bootstrap == 1) {
                $doc->addStyleSheet(JURI::base() . '/media/jui/css/bootstrap.min.css');
            }
            $latlng = $items[0]->latitude . "," . $items[0]->longitude;
            $map = JRequest::getVar('map', $params->get('map', 0));
            $str = null;
            $result = "";
            $address = null;
            $s = null;
            $cluster = $params->get('cluster', 1);
            $loc = null;
            $q = 0;
            $v = rand();
            if (empty($width)) {
                $width = MyMaplocationsHelper::formatField(JRequest::getVar('viewwidth', ($params->get('viewwidth', '60%'))));
            } else {
                $width = MyMaplocationsHelper::formatField($width);
            }
            if (empty($height)) {
                $height = MyMaplocationsHelper::formatField(JRequest::getVar('viewheight', ($params->get('viewheight', 400))));
            } else {
                $height = MyMaplocationsHelper::formatField($height);
            }
            if (!empty($type)) {
                if( ($type == "bing")||($type==1)) {
                    $map = 1;
                } else {
                    $map = 0;
                }
            }
            if (empty($items[0]->google_maptype)) {
                $items[0]->google_maptype = $params->get('google_maptype', 'ROADMAP');
            }
            if (empty($items[0]->bing_maptype)) {
                $items[0]->bing_maptype = $params->get('bing_maptype', 'road');
            }
            if(empty($items[0]->map_design))
            {
                $map_design=$params->get('map_design', 1);
            }else
            {
                $map_design=$items[0]->map_design;
            }
            $result.= "  <script type='text/javascript'> var icons_" . $v . "=[];";
            foreach ($items as $item) {
                if(($item->latitude==0)&&($item->longitude==0))
                {   
                    continue;
                }
                if(($item->latitude==255)&&($item->longitude==255))
                {
                    continue;
                }
                $address = "";
                $s = $item->id . "_" . $v;
                $data = array();
                if (($item->icon != null)) {
                    $icons = JURI::root(true) .'/'.$item->icon;
                } else {
                   $icons = "//chart.googleapis.com/chart?chst=d_map_pin_letter&chld=1|".str_replace("#","",$globalcolor)."|".str_replace("#","",$markercolor);
                }
                $data[] = MyMaplocationsHelper::formatJS('<strong><a href="' . MyMaplocationsHelper::getUrlLink($item) . '"><h3>' . $item->name . '</h3></a></strong><br/>' . $item->address . "<br/>");
                if (!empty($item->town)) {
                    $data[] = MyMaplocationsHelper::formatJS($item->town);
                }
                if (!empty($item->locationstate)) {
                    $data[] = MyMaplocationsHelper::formatJS($item->locationstate) . '<br/>';
                }
    
                if (!empty($item->country)) {
                    $data[] = MyMaplocationsHelper::formatJS($item->country);
                }
                if (!empty($item->postal)) {
                    $data[] = $item->postal;
                }
    
               $str.='"' . $item->latitude.",".$item->longitude . '",';
                if (!empty($item->logo)) {
                    $address.='<a href="' . MyMaplocationsHelper::getUrlLink($item) . '"><img src="' . $item->logo . '" style="float:left;" class="mml_logo"/></a>';
                }
                $address.=str_replace('<br/>,', '<br>', implode(",", $data));
                if (!empty($item->phone)) {
                    $address.='<br/><abbr title="Phone"><i class="mml-hand-right"></i></abbr><a href="tel:'. $item->phone .'" target="_blank">' . $item->phone. '</a><br/>';
                }
                $loc.="['" . $address . "', " . $item->latitude . ", " . $item->longitude . ", 6],";
                if ($item->icon != null) {
                    $result.="icons_" . $v . "[" . $q . "]='" . JURI::root(true) .'/'. $item->icon . "';";
                } else {
                   $result.="icons_" . $v . "[" . $q . "]='//chart.googleapis.com/chart?chst=d_map_pin_letter&chld=" . ($q + 1) . "|".str_replace("#","",$globalcolor)."|".str_replace("#","",$markercolor)."';";
                }
                $q++;
            }
            $result.="</script>";
            if ($map == 0) {
                if ($params->get('distance_type', 1) == 1) {
                    $dist = 'unitSystem: google.maps.UnitSystem.IMPERIAL';
                } else {
                    $dist = 'unitSystem: google.maps.UnitSystem.METRIC';
                }
                $script1 = "";
                $script2 = "";
                $script3 = "";
                 $script4="";
                  $script5="";
                if ($cluster == 1) {
                    $script1 = "<script
        type='text/javascript' src='//google-maps-utility-library-v3.googlecode.com/svn/trunk/markerclusterer/src/markerclusterer.js'></script>";
                    $script2 = "gmarkers.push(marker);";
                    $script3 = "var mcOptions = {gridSize: 50, maxZoom: 14};
                    var markerCluster = new MarkerClusterer(map" . $s . ",gmarkers,mcOptions);";
                }
                if($autozoom==1)
                {
                    $script4 ="map" . $s . ".fitBounds(bounds" . $s . ");";
                }
                if($map_design!=1){
                            $script5="styles:". MyMaplocationsHelper::getMapDesign($map_design);
                            
                            } 
    
    
                $result.="<style type='text/css'>.map_canvas img, #map img
            {
        max-width: none !important;
            }
            .map_canvas h3 {
    display: inline-block !important;
    }
     .gm-style-iw .resultbtn,.locationsearch .resultbtn,.cwell a.btn.btn-warning.resultbtn  {
        -moz-border-bottom-colors: none;
        -moz-border-left-colors: none;
        -moz-border-right-colors: none;
        -moz-border-top-colors: none;
        background: none repeat scroll 0 0 $globalcolor;
        border-color: -moz-use-text-color -moz-use-text-color $globalcolor;
        border-image: none;
        border-radius: 2px;
        border-style: none none solid;
        border-width: 0 0 2px;
        box-shadow: 0 -2px $globalcolor inset;
        color: #fff;
        cursor: pointer;
        display: inline-block;
        font-size: 15px;
        line-height: 22px;
        margin-left: 3px;
        text-align: center;
        text-decoration: none;
        text-shadow: 0 1px 2px rgba(0, 0, 0, 0.25);
        width: auto;
    }	</style>".MyMaplocationsHelper::loadGoogleJs()  . $script1 . "
        <script type='text/javascript'>
        google.maps.event.addDomListener(window, 'load', initialize" . $s . ");
          var marker" . $s . ";
          var map" . $s . ";
            var locations" . $s . " = [" . $loc . "];
                var panorama" . $s . ";
            var mapOptions" . $s . ";
          function initialize" . $s . "() {
           var total=locations" . $s . ".length;
           if(total>1)
            {
            var bounds" . $s . " = new google.maps.LatLngBounds();
            }
            var location" . $s . " = new google.maps.LatLng(" . $latlng . ");
            mapOptions" . $s . " = {
              zoom: " . $zoom . ",
              mapTypeId: google.maps.MapTypeId." . $items[0]->google_maptype . ",
              center: location" . $s . ",
              ".$script5."
            };
    
            map" . $s . " = new google.maps.Map(document.getElementById('map_canvas_" . $s . "'),
                    mapOptions" . $s . ");
            
            infowindow" . $s . " = new google.maps.InfoWindow();
            
                var i;
            var gmarkers = [];
                for (i = 0; i < locations" . $s . ".length; i++) {  
                  marker = new google.maps.Marker({
                    position: new google.maps.LatLng(locations" . $s . "[i][1], locations" . $s . "[i][2]),
                    map: map" . $s . ",
                    icon:icons_" . $v . "[i],
                    center: new google.maps.LatLng(" . $items[0]->latitude . "," . $items[0]->longitude . "),
                  });
                  " . $script2 . "
                  google.maps.event.addListener(marker, 'click', (function(marker" . $s . ", i) {
                    return function() {
                      infowindow" . $s . ".setContent(locations" . $s . "[i][0]+'<br/><input type=\"text\" class=\"input-medium\" name=\"distance" . $s . "\" id=\"distance" . $s . "\"><input type=\"button\" class=\"resultbtn btn btn-info\" value=\"" . JText::_("COM_MYMAPLOCATIONS_MAPLOCATION_ROUTE") . "\" onclick=\"getUIDirection" . $s . "('+i+');\"></input><br/><input type=\"button\" class=\"resultbtn btn btn-inverse\" value=\"" . JText::_("COM_MYMAPLOCATIONS_TOGGLE") . "\" onclick=\"toggleStreetView" . $s . "('+i+');\"></input>');
                      infowindow" . $s . ".open(map" . $s . ", marker" . $s . ");
                    }
                  })(marker, i));
                  if(total>1)
                    {
                  bounds" . $s . ".extend(marker.getPosition());
                  }
                }
                panorama" . $s . " = map" . $s . ".getStreetView();
      panorama" . $s . ".setPosition(location" . $s . ");
      panorama" . $s . ".setPov(/** @type {google.maps.StreetViewPov} */({
        heading: 265,
        pitch: 0
      }));
            if(total>1)
                    {
                    ".$script4."
                    }
                    " . $script3 . "
              }
                function launchInfoWindow(x) {
                google.maps.event.trigger(marker" . $s . "[x], 'click');
                }
                
                function toggleStreetView" . $s . "(i) {
            var cent= new google.maps.LatLng(locations" . $s . "[i][1], locations" . $s . "[i][2]);
            panorama" . $s . ".setPosition(cent);
      var toggle = panorama" . $s . ".getVisible();
        if (toggle == false) {
       panorama" . $s . ".setVisible(true);
         } else {
        panorama" . $s . ".setVisible(false);
         }
        }
            function getUIDirection" . $s . "(i)
                {
                    var location" . $s . " = new google.maps.LatLng(" . $latlng . ");
                    var source=document.getElementById('distance" . $s . "').value;
                    var destination=locations" . $s . "[i][1]+','+locations" . $s . "[i][2];
                    var directionsService = new google.maps.DirectionsService();
                    var directionsDisplay = new google.maps.DirectionsRenderer();
                    directionsDisplay.setPanel(document.getElementById('infobox_" . $s . "'));
                    
                    document.getElementById('infobox_" . $s . "').style.display='block';
                    document.getElementById('backtomap_" . $s . "').style.display='block';
                    document.getElementById('print_" . $s . "').style.display='block';
                    mapOptions" . $s . " = {
                    zoom: " . $zoom . ",
                    mapTypeId: google.maps.MapTypeId." . $items[0]->google_maptype . ",
                    center: location" . $s . ",
                    ".$script5."
                    };
                    map" . $s . " = new google.maps.Map(document.getElementById('map_canvas_" . $s . "'),
                    mapOptions" . $s . ");
                    directionsDisplay.setMap(map" . $s . ");
                    var trafficLayer" . $s . " = new google.maps.TrafficLayer();
                    trafficLayer" . $s . ".setMap(map" . $s . ");
                                    
                    var request = {
                        origin: source,
                        destination: destination,
                        travelMode: google.maps.DirectionsTravelMode.DRIVING,
                            " . $dist . ",
                    };
                    directionsService.route(request, function(response, status) {
                        if (status == google.maps.DirectionsStatus.OK) {
                            document.getElementById('infobox_" . $s . "').innerHTML = '';
                            directionsDisplay.setDirections(response);
                        }
                    });
    
                }
                  function backToMap" . $s . "()
                {
                    initialize" . $s . "();
                    document.getElementById('infobox_" . $s . "').style.display='none';
                    document.getElementById('backtomap_" . $s . "').style.display='none';
                    document.getElementById('print_" . $s . "').style.display='none';
    
                }
                 function printDiv" . $s ."(divID) {
            var divElements = document.getElementById(divID).innerHTML;
            var oldPage = document.body.innerHTML;
            document.body.innerHTML =divElements;
            window.print();
            document.body.innerHTML = oldPage;
                }
                function reinitialize()
                {
                     var script = document.createElement('script');
                    script.type = 'text/javascript';
                    script.src = '//maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&' +'callback=initialize" . $s . "';
                    document.body.appendChild(script);
    
                }
        </script>";
            if($s!=null)
                {
                $result.="<div class='map_canvas' id='map_canvas_" . $s . "'  style='width:" . $width . ";height:" . $height . ";float:left;position:relative;'></div><div class='infobox' id='infobox_" . $s . "' style='float:left;display:none'></div><input type=\"button\" class=\"resultbtn btn btn-danger\" id='backtomap_" . $s . "' style='display:none;float:left;' value=\"" . JText::_("COM_MYMAPLOCATIONS_BACK") . "\" onclick=\"backToMap" . $s . "();\"><input type=\"button\" class=\"resultbtn btn btn-primary\" id='print_" . $s . "' style='display:none;float:left;' value=\"" . JText::_("JGLOBAL_PRINT") . "\" onclick=\"printDiv" . $s . "('infobox_" . $s . "');\"></input>";
                }
            } else {
                MyMaplocationsHelper::loadBingJs();
                $result.="<style type='text/css'>.map_canvas img, #map img
            {
                max-width:100% !important;
            }
            .infobox-info
            {
                    background:white;
                    position:absolute;
            }
            .MapPushpinBase img
            {
            max-height:36px;
            }
            .btn {
            display: inline-block;
            *display: inline;
            *zoom: 1;
            padding: 4px 12px;
            margin-bottom: 0;
            font-size: 13px;
            line-height: 18px;
            text-align: center;
            vertical-align: middle;
            cursor: pointer;
            color: #333;
            text-shadow: 0 1px 1px rgba(255,255,255,0.75);
            background-color: #f5f5f5;
            background-image: -moz-linear-gradient(top,#fff,#e6e6e6);
            background-image: -webkit-gradient(linear,0 0,0 100%,from(#fff),to(#e6e6e6));
            background-image: -webkit-linear-gradient(top,#fff,#e6e6e6);
            background-image: -o-linear-gradient(top,#fff,#e6e6e6);
            background-image: linear-gradient(to bottom,#fff,#e6e6e6);
            background-repeat: repeat-x;
            filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffffff', endColorstr='#ffe5e5e5', GradientType=0);
            border-color: #e6e6e6 #e6e6e6 #bfbfbf;
            *background-color: #e6e6e6;
            filter: progid:DXImageTransform.Microsoft.gradient(enabled = false);
            border: 1px solid #bbb;
            *border: 0;
            border-bottom-color: #a2a2a2;
            -webkit-border-radius: 4px;
            -moz-border-radius: 4px;
            border-radius: 4px;
            *margin-left: .3em;
            -webkit-box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
            -moz-box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
            box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
    }
    button.btn.btn-primary.resultbtn, a.btn.btn-inverse.resultbtn, button.sample.btn.custom.large.a.pull-right.btn-danger.button, a.btn.btn-warning.resultbtn,.map-route .btn-inverse,.map-route .btn-info {
        -moz-border-bottom-colors: none;
        -moz-border-left-colors: none;
        -moz-border-right-colors: none;
        -moz-border-top-colors: none;
        background: none repeat scroll 0 0 #2980b9;
        border-color: -moz-use-text-color -moz-use-text-color #2475ab;
        border-image: none;
        border-radius: 2px;
        border-style: none none solid;
        border-width: 0 0 2px;
        box-shadow: 0 -2px #2475ab inset;
        color: #fff;
        cursor: pointer;
        display: inline-block;
        font-size: 15px;
        line-height: 22px;
        margin-left: 3px;
        text-align: center;
        text-decoration: none;
        text-shadow: 0 1px 2px rgba(0, 0, 0, 0.25);
        width: auto;
    }
    .MicrosoftMap .infobox-close
    {
        color:#ff0000;
    }
            </style>
                    <script type='text/javascript'>
                    window.addEventListener('load', function (){
                            initialize_" . $s . "();
                    });
                    var map_" . $s . " = null;
                    var pinInfobox_" . $s . " = null;
                    locations_" . $s . " = [" . $loc . "];
                var infoboxLayer_" . $s . " = new Microsoft.Maps.EntityCollection();
                var pinInfoBox_" . $s . ";  //the pop up info box
                var pinLayer_" . $s . " = new Microsoft.Maps.EntityCollection();
             function initialize_" . $s . "()
             {
                 var LLA_" . $s . " = [new Microsoft.Maps.Location(" . $items[0]->latitude . "," . $items[0]->longitude . ")];
                var r_" . $s . " = Microsoft.Maps.LocationRect.fromLocations(LLA_" . $s . ");
                var mapOptions_" . $s . " = { credentials:'" . $bingkey . "',
                                   center      : r_" . $s . ".center,
                                    mapTypeId   : Microsoft.Maps.MapTypeId." . $items[0]->bing_maptype . ",
                                    zoom        :" . $zoom . "
                                };
                map_" . $s . " = new Microsoft.Maps.Map(document.getElementById('map_canvas_" . $s . "'), mapOptions_" . $s . ");
            // Create the info box for the pushpin
            pinInfobox_" . $s . " = new Microsoft.Maps.Infobox(new Microsoft.Maps.Location(0, 0), { visible: false });
            infoboxLayer_" . $s . ".push(pinInfobox_" . $s . ");
            for (var i = 0 ; i <locations_" . $s . ".length; i++){
                
                //add pushpins
                var latLon_" . $s . " = new Microsoft.Maps.Location(locations_" . $s . "[i][1], locations_" . $s . "[i][2]);
                var pin_" . $s . " = new Microsoft.Maps.Pushpin(latLon_" . $s . ",{icon: icons_" . $v . "[i], width: 30, height: 50});
                pin_" . $s . ".Description =locations_" . $s . "[i][0] ; //information you want to display in the infobox
                pinLayer_" . $s . ".push(pin_" . $s . "); //add pushpin to pinLayer
                Microsoft.Maps.Events.addHandler(pin_" . $s . ", 'click', displayInfobox_" . $s . ");
            }
            map_" . $s . ".entities.push(pinLayer_" . $s . ");
                map_" . $s . ".entities.push(infoboxLayer_" . $s . ");
            }
    
             function displayInfobox_" . $s . "(e) {   
            pinInfobox_" . $s . ".setOptions({ description: e.target.Description, visible:true,offset:new Microsoft.Maps.Point(0,25),showPointer: false});
            pinInfobox_" . $s . ".setLocation(e.target.getLocation());
            }
    
        function hideInfobox_" . $s . "(e) {
            pinInfobox_" . $s . ".setOptions({ visible: false });
            }
          function launchInfoWindow_" . $s . "(x) {
                    var q=x-1;
                    var latLon = new Microsoft.Maps.Location(locations[q][1], locations[q][2]);
                     pinInfobox_" . $s . ".setOptions({ description: locations[q][0], visible:true, offset: new Microsoft.Maps.Point(0,25),showPointer: false});
                     pinInfobox_" . $s . ".setLocation(latLon);
                }
                function printDiv" . $s ."(divID) {
            var divElements = document.getElementById(divID).innerHTML;
            var oldPage = document.body.innerHTML;
            document.body.innerHTML =divElements;
            window.print();
            document.body.innerHTML = oldPage;
                }
        </script>";
                $result.="<div class='map_canvas' id='map_canvas_" . $s . "'  style='width:" . $width . ";height:" . $height . ";float:left;position:relative;'></div>";
            }
            return $result;
        }
    
        public function getLatLongFromPostcode($postcode) {
            /* remove spaces from postcode */
     
            $data = array();
            if(preg_match('/^(\-?\d+(\.\d+)?),\s*(\-?\d+(\.\d+)?)$/', $postcode,$match))
            {
                $data['lat'] = $match[1];
                $data['lang'] = $match[3];
                return $data;
            }
            $postcode = urlencode(trim($postcode));
            /* connect to the google geocode service */
            $file = "http://maps.googleapis.com/maps/api/geocode/json?address=$postcode&sensor=true";
            jimport('joomla.application.component.helper');
            $params = JComponentHelper::getParams('com_mymaplocations');
             $country=$params->get('country',null);
             if(!empty($country))
                    {
                        $file.="&components=country:".$country;
                    }
            $mode = $params->get('mode');
            $bingapi = $params->get('bingapi');
            $mapquestapi=$params->get('mapquestapi');
            if ($mode != 1) {
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $file);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                $geoloc = json_decode(curl_exec($ch), true);
        
                if ($geoloc['status'] == 'OK') {
                    $data['lat'] = $geoloc['results'][0]['geometry']['location']['lat'];
                    $data['lang'] = $geoloc['results'][0]['geometry']['location']['lng'];
                }
                 else
                {
                    $file="http://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/find?text=" . str_ireplace(" ", "%20", urldecode($postcode)) . "&f=pjson";
                    if(!empty($country))
                    {
                        $file.="&sourceCountry=".$country;
                    }
                    curl_setopt($ch, CURLOPT_URL, $file);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    $geoloc = json_decode(curl_exec($ch), true);
                    if($geoloc['locations'][0]['feature']['attributes']['Addr_Type']=="LatLong")
                    {
                    $data['lang'] = $geoloc['locations'][0]['feature']['geometry']['y'];
                    $data['lat'] = $geoloc ['locations'][0]['feature']['geometry']['x']; 
                    }
                    else
                    {
                    $data['lang'] = $geoloc['locations'][0]['feature']['geometry']['x'];
                    $data['lat'] = $geoloc ['locations'][0]['feature']['geometry']['y'];
                    }
                    
                }
                
                if (($bingapi != "")&&(empty($data['lang']))) {
    
                    $file = "http://dev.virtualearth.net/REST/v1/Locations/" . str_ireplace(" ", "%20", urldecode($postcode)) . "?key=$bingapi";
                    curl_setopt($ch, CURLOPT_URL, $file);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    $geoloc = json_decode(curl_exec($ch), true);
                    $data['lat'] = $geoloc ['resourceSets'][0]['resources'][0]['point']['coordinates'][0];
                    $data['lang'] = $geoloc ['resourceSets'][0]['resources'][0]['point']['coordinates'][1];
               
                }
            } else {
                $contents = file_get_contents($file);
                $geoloc = json_decode($contents);
                if ($geoloc->status == 'OK') {
                    $data['lat'] = $geoloc->results[0]->geometry->location->lat;
                    $data['lang'] = $geoloc->results[0]->geometry->location->lng;
                }
                else 
                {
                     $file="http://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/find?text=" . str_ireplace(" ", "%20", urldecode($postcode)) . "&f=pjson";
                     if(!empty($country))
                    {
                        $file.="&sourceCountry=".$country;
                    }
                    $contents = file_get_contents($file);
                    $geoloc = json_decode($contents, true);
                    if($geoloc['locations'][0]['feature']['attributes']['Addr_Type']=="LatLong")
                    {
                    $data['lang'] = $geoloc['locations'][0]['feature']['geometry']['y'];
                    $data['lat'] = $geoloc ['locations'][0]['feature']['geometry']['x']; 
                    }
                    else
                    {
                    $data['lang'] = $geoloc['locations'][0]['feature']['geometry']['x'];
                    $data['lat'] = $geoloc ['locations'][0]['feature']['geometry']['y'];
                    }
                    
                }
                
                if (($bingapi != "")&&(empty($data['lang']))) {
    
                    $file = "http://dev.virtualearth.net/REST/v1/Locations/" . str_ireplace(" ", "%20", urldecode($postcode)) . "?key=$bingapi";
                    $contents = file_get_contents($file);
                    $geoloc = json_decode($contents, true);
                    $data['lat'] = $geoloc ['resourceSets'][0]['resources'][0]['point']['coordinates'][0];
                    $data['lang'] = $geoloc ['resourceSets'][0]['resources'][0]['point']['coordinates'][1];
                }
            }
            return $data;
        }
    
        public function getCityList($cities) {
            $html = "";
            $html.="<span class='loclist'>";
            foreach ($cities as $key => $city) {
                if (($key - 1 == -1) || ($cities[$key]->country != $cities[$key - 1]->country)) {
                    $html.=("<h3>" . $city->country . "</h3>");
                }
    
                $html.=("<span class='location'><span class='locationstate'>" . $city->locationstate . "</span>,");
                $url = JRoute::_("index.php?option=com_mymaplocations&view=locations&city=" . $city->town);
                $html.="<span class='city'><a href='" . $url . "'>" . $city->town . "</a></span></span>";
            }
            $html.="</span>";
            return $html;
        }
    
        public static function getUrlLink($item) {
            
             if(empty($item->component))
            {
                $item->component=JRequest::getVar('component');
            }
            if ($item->component == "com_k2") {
                require_once (JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'route.php');
                require_once (JPATH_SITE . DS . 'components' . DS . 'com_k2' . DS . 'helpers' . DS . 'utilities.php');
                $url = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->extra_id . ':' . urlencode($item->k2alias), $item->k2catid)));
            }
            else if ($item->component == "com_comprofiler") {
                $url = urldecode(JRoute::_("index.php?option=com_comprofiler&task=userprofile&user=" . $item->extra_id));
            }
            else if($item->component == "com_hikamarket") {
                $url = urldecode(JRoute::_("index.php?option=com_hikashop&view=product&layout=show&cid=" . $item->product_id."&name=".str_replace(" ","-",strtolower($item->name))));
            }
            else if($item->component == "com_hikashop") {
                $url = urldecode(JRoute::_("index.php?option=com_hikamarket&ctrl=vendor&task=show&cid=" . $item->extra_id."&name=".$item->name));
            }
            else if($item->component=="com_community")
            {
                include_once(JPATH_BASE . '/components/com_community/defines.community.php');
                require_once(JPATH_BASE . '/components/com_community/libraries/core.php');
                $url=CRoute::_('index.php?option=com_community&view=profile&userid='.$item->id );
            }
            else if($item->component=="com_easysocial")
            {
                $url=$item->url;
            }
            else {
                $params = JComponentHelper::getParams('com_mymaplocations');
                $globalmenu=$params->get('globalmenu');
                if(!empty($globalmenu))
                {
                $url = JRoute::_("index.php?option=com_mymaplocations&view=location&id=" . $item->id."&Itemid=".$globalmenu);
                }
                else
                {
                $url = JRoute::_("index.php?option=com_mymaplocations&view=location&id=" . $item->id);
                }
            }
            return $url;
        }
    
        public static function formatField($field) {
            if (is_numeric($field)) {
                $field = $field . "px";
            }
            return $field;
        }
    
        public static function addLocalization() {
            $language = JFactory::getLanguage();
            $tag = $language->getTag();
            $lang = "";
            if (strpos($tag, 'ar') !== false) {
                $lang = "&amp;language=ar";
            } else if (strpos($tag, 'eu') !== false) {
                $lang = "&amp;language=eu";
            } else if (strpos($tag, 'bg') !== false) {
                $lang = "&amp;language=bg";
            } else if (strpos($tag, 'bn') !== false) {
                $lang = "&amp;language=bn";
            } else if (strpos($tag, 'ca') !== false) {
                $lang = "&amp;language=ca";
            } else if (strpos($tag, 'cs') !== false) {
                $lang = "&amp;language=cs";
            } else if (strpos($tag, 'da') !== false) {
                $lang = "&amp;language=da";
            } else if (strpos($tag, 'de') !== false) {
                $lang = "&amp;language=de";
            } else if (strpos($tag, 'el') !== false) {
                $lang = "&amp;language=el";
            } else if (strpos($tag, 'es') !== false) {
                $lang = "&amp;language=es";
            } else if (strpos($tag, 'fr') !== false) {
                $lang = "&amp;language=fr";
            } else if (strpos($tag, 'nl') !== false) {
                $lang = "&amp;language=nl";
            } else if (strpos($tag, 'it') !== false) {
                $lang = "&amp;language=it";
            }
            return $lang;
        }
    
        public static function formatJS($string) {
            $str = str_replace("\n", '\n', str_replace('"', '\"', addcslashes(str_replace("\r", '', (string) ($string)), "\0..\37'\\")));
            return $str;
        }
    
        public static function checkComponent($component) {
            jimport('joomla.filesystem.folder');
            if ((JFolder::exists(JPATH_SITE . '/components/' . $component . '/'))) {
                return true;
            } else {
                JFactory::getApplication()->enqueueMessage(JTEXT::_($component.' '.JTEXT::_('JERROR_LAYOUT_REQUESTED_RESOURCE_WAS_NOT_FOUND')));
                return false;
            }
        }
    
        public static function getLocationList($id = 0, $component = "com_mymaplocations", $limit = 0) {
            $options = MyMaplocationsHelper::getDataList($id, $component, $limit);
            if (empty($options)) {
                return;
            }
            $html = '<select class="maplist" onchange="top.location.href=this.options[this.selectedIndex].value" style="width: auto" name="locationlist">';
             $html.='<option value="">' . JText::_('JGLOBAL_SELECT_AN_OPTION') . '</option>';
            foreach ($options as $option) {
                $option->component = $component;
                $html.='<option value="' . MyMaplocationsHelper::getUrlLink($option) . '">' . $option->name . '</option>';
            }
            $html.="</select>";
            return $html;
        }
    public static function createVendorMap($vendor)
        {
     
            $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            $query->select('*');
            $query->from('#__mymaplocations_location');
            $query->where('extra_id = ' . $vendor->vendor_id);
            $query->where('component = ' . $db->quote('com_hikamarket')  );
            $db->setQuery($query);
            $result=$db->loadObject();
            $plugin = JPluginHelper::getPlugin('hikamarket', 'mymaplocations');
            $params = new JRegistry($plugin->params);
            $company=$params->get('vendor_company_column','vendor_address_company');
            $address=$params->get('vendor_address_column','vendor_address_street');
            $city=$params->get('vendor_city_column','vendor_address_city');
            $st=$params->get('vendor_state_column','vendor_address_state');
            $country=$params->get('vendor_country_column','vendor_address_country');
            $czip=$params->get('vendor_zip_column','vendor_address_post_code');
            $result->name= $vendor->$company;
            $result->address=$vendor->$address;
            $result->town=$vendor->$city;
            $sql = "select zone_name_english from #__hikashop_zone where zone_namekey=" . $db->Quote($vendor->$st);
                    $db->setQuery($sql);
                    $locstate= $db->loadObject();
            $result->locationstate=$locstate->zone_name_english;
            
            $sql = "select zone_name_english from #__hikashop_zone where zone_namekey=" . $db->Quote($vendor->$country);
            $db->setQuery($sql);
            $country= $db->loadObject();
            $result->country=$country->zone_name_english;
            $result->postal=$vendor->$czip;
            $res[]=$result;
            $map = MyMapLocationsHelper::CreateMap($res);
            return $map;
        }
            public function getHikaprice($pid,$tax_id)
        {
            $arr = array();
    $arr[0] = new stdClass();
    $arr[0]->product_id = $pid;
    $arr[0]->product_tax_id = $tax_id;
    $currency = hikashop_get('type.currency');
    $currencyClass = hikashop_get('class.currency');
    $zone = hikashop_getZone();
    $cur = hikashop_getCurrency();
    $currencyClass->getListingPrices($arr,$zone,$cur);
    $i=0;
    $currPrice = 0;
    foreach($arr[0]->prices as $k=>$price) {
    if(!$i) {
    $currPrice = $price->price_value_with_tax;
    }
    if($price->price_value_with_tax < $currPrice) $currPrice = $price->price_value_with_tax;
    $i++;
    }
    
    return $currencyClass->format($currPrice, $cur);
        }
        public static function getDataList($id = 0, $component = "com_mymaplocations", $limit = 0) {
    
            $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            $query->select($db->quoteName(array('id', 'name')));
            $query->from('#__mymaplocations_location');
            $query->where('id != ' . $id);
            if ($component == "com_mymaplocations") {
                $query->where(' ( component = ' . $db->quote($component) . ' OR component=' . $db->quote("") . ') ');
            } else {
                $query->where(' component = ' . $db->quote($component));
            }
            $query->where('state= 1');
            $query->order('name ASC');
            $db->setQuery($query);
            if ($db->getErrorNum()) {
                echo $db->getErrorMsg();
                exit;
            }
    
            return $db->loadObjectList();
        }
    
        public static function loadLanguage() {
            $lang = JFactory::getLanguage();
            $lang->load('com_mymaplocations', JPATH_ADMINISTRATOR);
        }
    
        public static function createContactLink($contactlink, $target) {
            $btn = "";
            switch ($target) {
                case 1:
                    // open in a new window
                    $btn = '<a href="' . $contactlink . '" target="_blank" class="resultbtn btn btn-success" rel="nofollow">' .
                            JText::_('COM_MYMAPLOCATIONS_CONTACT') . '</a>';
                    break;
    
                case 2:
                    // open in a popup window
                    $attribs = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes';
                    $btn = "<a href=\"$contactlink\" onclick=\"window.open(this.href, 'targetWindow', '" . $attribs . "'); return false;\" class='resultbtn btn btn-success'>" .
                            JText::_('COM_MYMAPLOCATIONS_CONTACT') .  '</a>';
                    break;
                case 3:
                    // open in a modal window
                    $btn = JHtml::_('behavior.modal', 'a.modal');
                    $btn.= '<a class="modal  resultbtn btn btn-success" href="' .$contactlink . '"  rel="{handler: \'iframe\'}">' .
                            JText::_('COM_MYMAPLOCATIONS_CONTACT') . ' </a>';
                    break;
    
                default:
                    // open in parent window
                    $btn = '<a href="' . $contactlink . '" rel="nofollow" class="resultbtn btn btn-success">' .
                            JText::_('COM_MYMAPLOCATIONS_CONTACT') . ' </a>';
                    break;
            }
            return $btn;
        }
        public static function getCommunityAddress($userid) {
                    require_once( JPATH_ROOT .'/components/com_community/libraries/core.php');
                    $config	= CFactory::getConfig();
                    $user	= CFactory::getUser($userid);
                    $params	= $user->getParams();
                            $fields = $config->get('user_address_fields');
                            $fieldsInArray = explode(',', $fields);
                            $lang = JFactory::getLanguage();
                            $lang->load( 'com_community.country',JPATH_SITE);
                            $address="";
                            foreach ($fieldsInArray as $key => $value) {
                            $info = JText::_($user->getInfo($value));
                            $address .= (!empty($info) ) ? "$info," : '';
                            }
                            return $address;
        }
         public static function getCommunityLogo($userid) {
            require_once( JPATH_ROOT .'/components/com_community/libraries/core.php');
                $config	= CFactory::getConfig();
                $user	= CFactory::getUser($userid);
                $avatar=str_replace(JURI::root(),'',$user->getThumbAvatar());
                    return $avatar;
         }
         public static function getCbField()
         {
             $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            $query->select($db->quoteName('params'));
            $query->from('#__comprofiler_plugin');
            $query->where(' element = ' . $db->quote('mymaplocations'));
              $db->setQuery($query);
            if ($db->getErrorNum()) {
                echo $db->getErrorMsg();
                exit;
            }
            $result= $db->loadObject();
               $param=json_decode($result->params,true);
                if(empty($param))
            {
                $param=parse_ini_string($result->params);
            }
            $usedefault=$param['usedefault'];
            
            if($usedefault==0)
            {
                return;
            }
            $data=array();
            if(!empty($param['address']))
            $data[]=$param['address'];
            if(!empty($param['city']))
            $data[]=$param['city'];
            if(!empty($param['locationstate']))
            $data[]=$param['locationstate'];
            if(!empty($param['country']))
            $data[]=$param['country'];
            if(!empty($param['postal']))
            $data[]=$param['postal'];
            
            $sql = "SELECT name from  #__comprofiler_fields where fieldid IN (".implode(',', $data).")";
            $db->setQuery($sql);
            $fieldDatas = $db->loadObjectList();
            return 	$fieldDatas;
         }
        public static function getCbAddress($item,$mmlfield)
         {
            foreach($mmlfield as $mmlfiel)
            {
                $field=$mmlfiel->name;
                $address[]=$item->$field;
            }
           return implode(',', $address);
         }
         public static function getAdvanceCommunitySearch($component)
         {
            if($component=="com_community")
            {
            $plugin = JPluginHelper::getPlugin('community', 'mymaplocations');
            $params = new JRegistry($plugin->params);
            return $params->get('showadvsearch');
            }
             if($component=="com_comprofiler")
            {
                $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            $query->select($db->quoteName('params'));
            $query->from('#__comprofiler_plugin');
            $query->where(' element = ' . $db->quote('mymaplocations'));
              $db->setQuery($query);
            if ($db->getErrorNum()) {
                echo $db->getErrorMsg();
                exit;
            }
            $result= $db->loadObject();
            $param=json_decode($result->params,true);
            if(empty($param))
            {
                $param=parse_ini_string($result->params);
            }
            
            if($param['userlist']==0)
            {
                return true;
            }
            else
            {
                   return false;
            }
            }
            return false;
         }
         public static function getAdvanceSearchDiv($component)
         {
            $html="";
            if($component=="com_community")
            {
                $lang = JFactory::getLanguage();
                $lang->load('mod_datingsearch', JPATH_SITE);
                $lang->load('com_community', JPATH_SITE);
                require_once ( JPATH_ROOT .'/components/com_community/libraries/core.php' );
                require_once ( JPATH_ROOT .'/modules/mod_datingsearch/helper.php' );
                $plugin = JPluginHelper::getPlugin('community', 'mymaplocations');
                $params = new JRegistry($plugin->params);
                $field = new stdClass();
                $field->code =  new stdClass();
                $field->code->gender 	= $params->get('field_gender', 'FIELD_GENDER');
                $field->code->birthdate = $params->get('field_birthdate', 'FIELD_BIRTHDATE');
                $field->value = new stdClass();
                $field->value->gender	= modDatingSearchHelper::getGenderValue($field->code->gender);
                $field->type = modDatingSearchHelper::getFieldType($field->code);
                $gender = JRequest::getVar('datingsearch_gender');
              
                $agefrom= JRequest::getVar('datingsearch_agefrom');
                $ageto = JRequest::getVar('datingsearch_ageto');
                $html.=JText::_('MOD_DATINGSEARCH_LOOKING_FOR')."";
                $html.='<select id="datingsearch_gender" name="datingsearch_gender" style="width:96px;">';
                $html.='<option value=""';
                if($gender=='') $html.=' selected';
                $html.='>'.JText::_('MOD_DATINGSEARCH_GENDER').'</option>';
                
                foreach($field->value->gender as $key=>$data)
                            {
                            $html.='<option value="'.$data.'" ';
                            if($gender==$data) $html.='selected';
                            $html.='>'.JText::_($data).'</option>';
                            }
                $html.='</select>';    
                $html.="<br/>".JText::_('MOD_DATINGSEARCH_AGE_BETWEEN')."";
                $html.='<input type="text" style="width:28px;" maxlength=3 id="datingsearch_agefrom" name="datingsearch_agefrom" value="'.$agefrom.'"/>'.JText::_("MOD_DATINGSEARCH_TO").'<input type="text" style="width:28px;" maxlength=3 id="datingsearch_ageto" name="datingsearch_ageto" value="'. $ageto.'"/>';
    
            }
             if($component=="com_comprofiler")
            {
                $cb_list=JRequest::getVar('cb_list');
               
                $db = JFactory::getDBO();
                $sql="SELECT listid, title FROM #__comprofiler_lists where published=1";
                $db->setQuery($sql);
                $rows = $db->loadObjectList();
                $html.='<select id="cb_list" name="cb_list">';
                $html.='<option value=""';
                if( $cb_list=='') $html.=' selected';
                $html.='>'.JText::_('JOPTION_SELECT_CATEGORY').'</option>';
                foreach($rows as $row)
                            {
                            $html.='<option value="'.$row->listid.'" ';
                            if($cb_list==$row->listid) $html.='selected';
                            $html.='>'.JText::_($row->title).'</option>';
                            }
                $html.='</select>';    
                
            }
            return $html;
         }
         public static function getcountryList()
         {
            $country_list=JRequest::getVar('country_list');
            $db = JFactory::getDBO();
                $sql="SELECT distinct(country),country as listid , country as title FROM #__mymaplocations_location where state=1 ORDER By country";
                $db->setQuery($sql);
    
                $html="";
                $rows = $db->loadObjectList();
                 $c=0;
                $html.='<select id="country_list" class="conutry_dropdown" name="country_list">';
                $html.='<option value=""';
                if( $country_list=='') $html.=' selected';
                $html.='>'.JText::_('COM_MYMAPLOCATIONS_FORM_LBL_STORE_COUNTRY').'</option>';
                foreach($rows as $row)
                            {
                               if(empty($row->listid))
                                {}
                                else if($row->title)
                                {
                                    $c++;
                            $html.='<option value="'.$row->listid.'" ';
                            if($country_list==$row->listid) $html.='selected';
                            $html.='>'.JText::_($row->title).'</option>';
                                }
                            }
                            if($c==0)
                            {
                                return;
                            }
                $html.='</select>';
                return $html;
                
         }
         public static function getstateList($country)
         {
            $state_list=JRequest::getVar('state_list');
           $html="";
            $db = JFactory::getDBO();
                $sql="SELECT distinct(locationstate),locationstate as listid , locationstate as title FROM #__mymaplocations_location where state=1 and country=".$db->quote($country)." ORDER By locationstate";
                $db->setQuery($sql);
                $rows = $db->loadObjectList();
               
                if(count($rows)==1)
                {
                    if(empty($rows[0]->listid))
                    {
                    return;
                    }
                }
                $html.='<br/><select id="state_list" class="conutry_dropdown" name="state_list">';
                $html.='<option value=""';
                if(  $state_list=='') $html.=' selected';
                $html.='>'.JText::_('COM_MYMAPLOCATIONS_FORM_LBL_STORE_STORESTATE').'</option>';
                foreach($rows as $row)
                            {
                                if(empty($row->listid))
                                {}
                                else if($row->title)
                                {
                            $html.='<option value="'.$row->listid.'" ';
                            if($state_list==$row->listid) $html.='selected';
                            $html.='>'.JText::_($row->title).'</option>';
                                }
                            }
                $html.='</select>';
                return $html;
                
         }
         public static function getJoomsocialField($genderfield,$birthdate)
         {
                        $db = JFactory::getDBO();
                        $sql = "SELECT
                                                            ".$db->quoteName("fieldcode").",
                                                            ".$db->quoteName("id")."
                                            FROM
                                                            ".$db->quoteName("#__community_fields")."
                                            WHERE
                                                            ".$db->quoteName("fieldcode")." IN (".$db->Quote($genderfield).", ".$db->Quote( $birthdate).")";
    
                            $db->setQuery($sql);
                            $row = $db->loadObjectList();
                            return $row;
                        
         }
          public static function getHikaCategory()
         {
            require_once (JPATH_SITE .'/administrator/components/com_hikashop/helpers/helper.php');
            require_once (JPATH_SITE .'/administrator/components/com_hikashop/classes/category.php');
            $hikashopCategoryClass=new hikashopCategoryClass();
            $lists=$hikashopCategoryClass->getList('product',0,true);
            $html="";
            $product_category=JRequest::getVar('product_category');
            $searchproduct=JRequest::getVar('searchproduct');
              $html.='<input type="text" autocomplete="off" value="'.$searchproduct.'" name="searchproduct" id="searchproduct" class="search-query" placeholder="'.JText::_("COM_MYMAPLOCATIONS_PRODUCT_SEARCH").'">';
              $html.='<select id="product_category" name="product_category">';
                $html.='<option value=""';
                if($product_category=='') $html.=' selected';
                $html.='>'.JText::_('JOPTION_SELECT_CATEGORY').'</option>';
                foreach($lists as $data)
                            {
                            if($data->category_depth==0)
                            {
                                continue;
                            }
                            $html.='<option value="'.$data->category_id.'" ';
                            if($product_category==$data->category_id) $html.='selected';
                            $html.='>';
                            if($data->category_depth > 0)
                            {
                               
                                for($n=0;$n<=$data->category_depth;$n++)
                                {
                                    $html.="-";
                                }
                            }
                            $html.=JText::_($data->category_name);
                            $html.='</option>';
                            }
                $html.='</select>';    
             return $html;
         }
         public static function getMapDesign($id)
         {
            if($id==2)
            {
                return '[{"featureType": "all","stylers": [{"saturation": -100},{"gamma": 0.5}]}]';
            }
            else if($id==3)
            {
            return '[{"featureType": "water","elementType": "geometry","stylers": [
                {
                    "color": "#a2daf2"
                }
            ]
        },
        {
            "featureType": "landscape.man_made",
            "elementType": "geometry",
            "stylers": [
                {
                    "color": "#f7f1df"
                }
            ]
        },
        {
            "featureType": "landscape.natural",
            "elementType": "geometry",
            "stylers": [
                {
                    "color": "#d0e3b4"
                }
            ]
        },
        {
            "featureType": "landscape.natural.terrain",
            "elementType": "geometry",
            "stylers": [
                {
                    "visibility": "off"
                }
            ]
        },
        {
            "featureType": "poi.park",
            "elementType": "geometry",
            "stylers": [
                {
                    "color": "#bde6ab"
                }
            ]
        },
        {
            "featureType": "poi",
            "elementType": "labels",
            "stylers": [
                {
                    "visibility": "off"
                }
            ]
        },
        {
            "featureType": "poi.medical",
            "elementType": "geometry",
            "stylers": [
                {
                    "color": "#fbd3da"
                }
            ]
        },
        {
            "featureType": "poi.business",
            "stylers": [
                {
                    "visibility": "off"
                }
            ]
        },
        {
            "featureType": "road",
            "elementType": "geometry.stroke",
            "stylers": [
                {
                    "visibility": "off"
                }
            ]
        },
        {
            "featureType": "road",
            "elementType": "labels",
            "stylers": [
                {
                    "visibility": "off"
                }
            ]
        },
        {
            "featureType": "road.highway",
            "elementType": "geometry.fill",
            "stylers": [
                {
                    "color": "#ffe15f"
                }
            ]
        },
        {
            "featureType": "road.highway",
            "elementType": "geometry.stroke",
            "stylers": [
                {
                    "color": "#efd151"
                }
            ]
        },
        {
            "featureType": "road.arterial",
            "elementType": "geometry.fill",
            "stylers": [
                {
                    "color": "#ffffff"
                }
            ]
        },
        {
            "featureType": "road.local",
            "elementType": "geometry.fill",
            "stylers": [
                {
                    "color": "black"
                }
            ]
        },
        {
            "featureType": "transit.station.airport",
            "elementType": "geometry.fill",
            "stylers": [
                {
                    "color": "#cfb2db"
                }
            ]
        }
    ]';
            }
            else if($id==4)
            {
                return '[
        {
            "featureType": "water",
            "elementType": "all",
            "stylers": [
                {
                    "color": "#3b5998"
                }
            ]
        },
        {
            "featureType": "administrative.province",
            "elementType": "all",
            "stylers": [
                {
                    "visibility": "on"
                }
            ]
        },
        {
            "featureType": "all",
            "elementType": "all",
            "stylers": [
                {
                    "hue": "#3b5998"
                },
                {
                    "saturation": -22
                }
            ]
        },
        {
            "featureType": "landscape",
            "elementType": "all",
            "stylers": [
                {
                    "visibility": "on"
                },
                {
                    "color": "#f7f7f7"
                },
                {
                    "saturation": 10
                },
                {
                    "lightness": 76
                }
            ]
        },
        {
            "featureType": "landscape.natural",
            "elementType": "all",
            "stylers": [
                {
                    "color": "#f7f7f7"
                }
            ]
        },
        {
            "featureType": "road.highway",
            "elementType": "all",
            "stylers": [
                {
                    "color": "#8b9dc3"
                }
            ]
        },
        {
            "featureType": "administrative.country",
            "elementType": "geometry.stroke",
            "stylers": [
                {
                    "visibility": "on"
                },
                {
                    "color": "#3b5998"
                }
            ]
        },
        {
            "featureType": "road.highway",
            "elementType": "all",
            "stylers": [
                {
                    "visibility": "on"
                },
                {
                    "color": "#8b9dc3"
                }
            ]
        },
        {
            "featureType": "road.highway",
            "elementType": "all",
            "stylers": [
                {
                    "visibility": "on"
                },
                {
                    "color": "#8b9dc3"
                }
            ]
        },
        {
            "featureType": "transit.line",
            "elementType": "all",
            "stylers": [
                {
                    "invert_lightness": false
                },
                {
                    "color": "#ffffff"
                },
                {
                    "weight": 0.43
                }
            ]
        },
        {
            "featureType": "road.highway",
            "elementType": "labels.icon",
            "stylers": [
                {
                    "visibility": "on"
                }
            ]
        },
        {
            "featureType": "road.local",
            "elementType": "geometry.fill",
            "stylers": [
                {
                    "color": "#8b9dc3"
                }
            ]
        },
        {
            "featureType": "administrative",
            "elementType": "labels.icon",
            "stylers": [
                {
                    "visibility": "on"
                },
                {
                    "color": "#3b5998"
                }
            ]
        }
    ]						';
            }
             else if($id==5)
            {
                return '[{"stylers":[{"hue":"#ff8800"},{"gamma":0.4}]}]';
            }
            else if($id==6)
            {
                
                return '[{"featureType":"all","elementType":"all","stylers":[{"invert_lightness":true},{"saturation":10},{"lightness":30},{"gamma":0.5},{"hue":"#435158"}]}]';
            }
            else if($id==7)
            {
                return '[{"featureType":"road","stylers":[{"hue":"#5e00ff"},{"saturation":-79}]},{"featureType":"poi","stylers":[{"saturation":-78},{"hue":"#6600ff"},{"lightness":-47},{"visibility":"off"}]},{"featureType":"road.local","stylers":[{"lightness":22}]},{"featureType":"landscape","stylers":[{"hue":"#6600ff"},{"saturation":-11}]},{},{},{"featureType":"water","stylers":[{"saturation":-65},{"hue":"#1900ff"},{"lightness":8}]},{"featureType":"road.local","stylers":[{"weight":1.3},{"lightness":30}]},{"featureType":"transit","stylers":[{"visibility":"simplified"},{"hue":"#5e00ff"},{"saturation":-16}]},{"featureType":"transit.line","stylers":[{"saturation":-72}]},{}]';
            }
            else if($id==8)
            {
                return '[{"featureType":"water","stylers":[{"saturation":43},{"lightness":-11},{"hue":"#0088ff"}]},{"featureType":"road","elementType":"geometry.fill","stylers":[{"hue":"#ff0000"},{"saturation":-100},{"lightness":99}]},{"featureType":"road","elementType":"geometry.stroke","stylers":[{"color":"#808080"},{"lightness":54}]},{"featureType":"landscape.man_made","elementType":"geometry.fill","stylers":[{"color":"#ece2d9"}]},{"featureType":"poi.park","elementType":"geometry.fill","stylers":[{"color":"#ccdca1"}]},{"featureType":"road","elementType":"labels.text.fill","stylers":[{"color":"#767676"}]},{"featureType":"road","elementType":"labels.text.stroke","stylers":[{"color":"#ffffff"}]},{"featureType":"poi","stylers":[{"visibility":"off"}]},{"featureType":"landscape.natural","elementType":"geometry.fill","stylers":[{"visibility":"on"},{"color":"#b8cb93"}]},{"featureType":"poi.park","stylers":[{"visibility":"on"}]},{"featureType":"poi.sports_complex","stylers":[{"visibility":"on"}]},{"featureType":"poi.medical","stylers":[{"visibility":"on"}]},{"featureType":"poi.business","stylers":[{"visibility":"simplified"}]}]';
            }
            else if($id==9)
            {
                return '[{"featureType":"landscape.natural","elementType":"geometry.fill","stylers":[{"visibility":"on"},{"color":"#e0efef"}]},{"featureType":"poi","elementType":"geometry.fill","stylers":[{"visibility":"on"},{"hue":"#1900ff"},{"color":"#8EF1DD"}]},{"featureType":"landscape.man_made","elementType":"geometry.fill"},{"featureType":"road","elementType":"geometry","stylers":[{"lightness":100},{"visibility":"simplified"}]},{"featureType":"road","elementType":"labels","stylers":[{"visibility":"off"}]},{"featureType":"water","stylers":[{"color":"#73D4C0"}]},{"featureType":"transit.line","elementType":"geometry","stylers":[{"visibility":"on"},{"lightness":700}]}]';
            }
            else if($id==10)
            {
                return '[{"featureType":"water","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":17}]},{"featureType":"landscape","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":20}]},{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#000000"},{"lightness":17}]},{"featureType":"road.highway","elementType":"geometry.stroke","stylers":[{"color":"#000000"},{"lightness":29},{"weight":0.2}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":18}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":16}]},{"featureType":"poi","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":21}]},{"elementType":"labels.text.stroke","stylers":[{"visibility":"on"},{"color":"#000000"},{"lightness":16}]},{"elementType":"labels.text.fill","stylers":[{"saturation":36},{"color":"#000000"},{"lightness":40}]},{"elementType":"labels.icon","stylers":[{"visibility":"off"}]},{"featureType":"transit","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":19}]},{"featureType":"administrative","elementType":"geometry.fill","stylers":[{"color":"#000000"},{"lightness":20}]},{"featureType":"administrative","elementType":"geometry.stroke","stylers":[{"color":"#000000"},{"lightness":17},{"weight":1.2}]}]';
            }
         }
        
         public static function utf8RawUrlDecode ($source, $charset = null ) {
    
            
    
            $decodedStr = '';
    
            $pos = 0;
    
            $len = strlen ($source);
    
            while ($pos < $len) {
    
                    $charAt = substr ($source, $pos, 1);
    
                    if ($charAt=='%') {
    
                            $pos++;
    
                            $charAt = substr ($source, $pos, 1);
    
                            if ($charAt=='u') { // we got a unicode character
    
                                    $pos++;
    
                                    $unicodeHexVal = substr ($source, $pos, 4);
    
                                    $unicode = hexdec ($unicodeHexVal);
    
                                    $entity = "&#". $unicode . ';';
    
                                    $decodedStr .= html_entity_decode($entity, ENT_QUOTES, $charset );
    
                                    $pos += 4;
    
                            } else { // we have an escaped ascii character
    
                                    $hexVal = substr ($source, $pos, 2);
    
                                    if ( $charset == 'UTF-8' ) {
    
                                            $decodedStr .= utf8_encode( chr( hexdec( $hexVal ) ) );
    
                                    } else {
    
                                            $decodedStr .= chr( hexdec( $hexVal ) );
    
                                    }
    
                                    $pos += 2;
    
                            }
    
                    } else {
    
                            $decodedStr .= $charAt;
    
                            $pos++;
    
                    }
    
            }
    
            return $decodedStr;
    
    }
    
    
    }

