<?php

/**
 * @version    2.2.12
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * ****@author      joomunited - contact@joomunited.com
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');
jimport('joomla.application.categories');

/**
 * Methods supporting a list of MyMaplocations records.
 */
class MyMaplocationsModellocations extends JModelList {

    /**
     * Constructor.
     *
     * @param    array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
    public function __construct($config = array()) {
        parent::__construct($config);
    }

    /**
     * Method to auto-populate the model state.
     *
     * Note. Calling getState in this method will result in recursion.
     *
     * @since	1.6
     */
    protected function populateState($ordering = null, $direction = null) {

        // Initialise variables.
        $app = JFactory::getApplication();

        // List state information
        $limit = 0;
        $this->setState('list.limit', $limit);

        $limitstart = 0;
        $this->setState('list.start', $limitstart);
        $search = $app->getUserStateFromRequest($this->context . '.filter.zip', 'searchzip');
        $this->setState('filter.zip', $search);
        $radius = $app->getUserStateFromRequest($this->context . '.filter.radius', 'radius');
        $this->setState('filter.radius', $radius);
        $catid = $app->getUserStateFromRequest($this->context . '.filter.category', 'filter_catid');
        $this->setState('filter.category', $catid);
        $component = $app->getUserStateFromRequest($this->context . '.filter.component', 'component');
        $this->setState('filter.component', $component);
        $this->setState('filter.language', JLanguageMultilang::isEnabled());
        $k2_catid = $app->getUserStateFromRequest($this->context . '.filter.k2_catid', 'k2_catid');
        $this->setState('filter.k2_catid', $k2_catid);
        $country_list = $app->getUserStateFromRequest($this->context . '.filter.country_list', 'country_list');
        $this->setState('filter.country_list', $country_list);
         $state_list= $app->getUserStateFromRequest($this->context . '.filter.state_list', 'state_list');
        $this->setState('filter.state_list', $state_list);
        
        // List state information.
        parent::populateState();
    }

    /**
     * Build an SQL query to load the list data.
     *
     * @return	JDatabaseQuery
     * @since	1.6
     */
    protected function getListQuery() {
        // Create a new query object.
        $location = array();
        $city = JRequest::getVar('city');
        $component = $this->getState('filter.component');
        if (!empty($city)) {
           /* $db = $this->getDbo();
            $query = $db->getQuery(true);
            $query->select('a.*');
            $query->from('`#__mymaplocations_location` AS a');
            if ($component == "com_k2") {
                $query->join('LEFT', '#__k2_items AS k ON k.id = a.extra_id');
            }
            

            // Filter by published state
            $published = 1;
            $query->where('a.state = ' . (int) $published);
            $query->where('a.town = ' . $db->Quote($city));
            if (!empty($catid)) {
                $query->where('a.catid = ' . (int) $catid);
            }
            if ($component == "com_k2") {
                $query->where(' a.component = ' . $db->quote($component));
                $query->where(' k.published =1 AND k.trash=0');
            } else {
                $query->where(' ( a.component = ' . $db->quote($component) . ' OR a.component=' . $db->quote("") . ') ');
            }

            //echo nl2br(str_replace('#__','jos_',$query));die();*/
        } else {
            $catid = $this->getState('filter.category');
            $zipcode = $this->getState('filter.zip');
            $k2_catid = $this->getState('filter.k2_catid');
            $country_list= $this->getState('filter.country_list');
            $state_list=$this->getState('filter.state_list');
            if (empty($zipcode)) {
                return;
            }
            $radius = $this->getState('filter.radius');

            @$zip = MyMaplocationsHelper::getLatLongFromPostcode($zipcode);
            $db = $this->getDbo();
            $query = $db->getQuery(true);
            $params = JComponentHelper::getParams('com_mymaplocations');
            $type = $params->get('distance_type', 1);
            if ($type == 1) {
                $distance = 3959;
            } else {
                $distance = 6371;
            }
            // Select the required fields from the table.
             if($component=="com_community")
            {
                $query->select(
                    $this->getState(
                            "list.select", " a.* ,( " . $distance . " * acos( cos( radians(" . $zip['lat'] . ") ) * cos( radians( a.latitude ) ) * cos( radians( a.longitude ) - radians( " . $zip['lang'] . ") ) + sin( radians( " . $zip['lat'] . ") ) * sin( radians( a.latitude ) ) ) ) AS distance "
                    )
                    );
                $query->select('a.*');
                $query->select('a.userid as id,a.avatar as logo, a.thumb as icon');
                $query->select('l.name as name');
                $query->where(' l.block =0');
                $datingsearch_gender=JRequest::getVar('datingsearch_gender');
                $datingsearch_agefrom=JRequest::getInt('datingsearch_agefrom');
                $datingsearch_ageto=JRequest::getInt('datingsearch_ageto');
                if(!empty( $datingsearch_gender)||(!empty($datingsearch_ageto)))
                {
                    
                    require_once( JPATH_ROOT .'/components/com_community/libraries/core.php');
                    $plugin = JPluginHelper::getPlugin('community', 'mymaplocations');
                    $params = new JRegistry($plugin->params);
                    $genderfield=$params->get('field_gender','FIELD_GENDER');
                    $birthdate=$params->get('field_birthdate','FIELD_BIRTHDATE');
                    $fields=MyMaplocationsHelper::getJoomsocialField($genderfield,$birthdate);
                    foreach($fields as $field)
                    {
                        if($field->fieldcode==$genderfield)
                        {
                            $genderid=$field->id;
                        }
                        if($field->fieldcode==$birthdate)
                        {
                            $birthid=$field->id;
                        }
                    }
                    $datetime0 = new Datetime();
				$datetime0->modify('-'.$datingsearch_ageto . ' year');
				$date1 = $datetime0->format('Y-m-d 00:00:00');

				$datetime1 = new Datetime();
				$datetime1->modify('-'.$datingsearch_agefrom . ' year');
				$date2 = $datetime1->format('Y-m-d 23:59:59');
                                if(!empty($datingsearch_gender))
                                {
                                
                    $datingsearch_gender = $db->quote('%' . $db->escape($datingsearch_gender, true) . '%', false);
                    $query->where(' b.value LIKE'.$datingsearch_gender);
                    $query->where(' b.field_id ='. $db->quote($genderid));
                                }
                                if(!empty($datingsearch_ageto)||!empty($datingsearch_agefrom))
                                {
                    $query->where(" DATE_FORMAT(c.value,'%Y-%m-%d %H:%i:%s') BETWEEN ".$db->quote($date1)." AND ".$db->quote($date2)." ");
                    $query->where(' c.field_id ='. $db->quote($birthid));
                                }
                }
                $query->from('`#__community_users` AS a');
                $query->join('LEFT', '#__users AS l ON l.id = a.userid');
                if(!empty( $datingsearch_gender))
                {
                    $query->join('LEFT', '#__community_fields_values AS b ON a.userid = b.user_id');
                     
                }
                if(!empty($datingsearch_ageto)||!empty($datingsearch_agefrom))
                    {
                $query->join('LEFT', '#__community_fields_values AS c ON a.userid = c.user_id');
                    }
                
                //echo nl2br(str_replace('#__','jos_',$query));die();
                
            }
            else  if($component=="com_easysocial")
            {
                $query->select(
                    $this->getState(
                            "list.select", " a.* ,( " . $distance . " * acos( cos( radians(" . $zip['lat'] . ") ) * cos( radians( m.raw ) ) * cos( radians( n.raw ) - radians( " . $zip['lang'] . ") ) + sin( radians( " . $zip['lat'] . ") ) * sin( radians( m.raw ) ) ) ) AS distance "
                    )
                    );
                $query->select('a.user_id as id');
                $query->select('l.name as name');
                $query->select('m.raw as latitude');
                $query->select('n.raw as longitude');
                $query->where(' l.block =0');
                $query->where(' a.type ='.$db->quote('joomla'));
                $query->where(' m.datakey ='.$db->quote('latitude'));
                $query->where('n.datakey ='.$db->quote('longitude'));
                $query->from('`#__social_users` AS a');
                $query->join('LEFT', '#__users AS l ON l.id = a.user_id');
                $query->join('LEFT', '#__social_fields_data AS m ON l.id = m.uid');
                $query->join('LEFT', '#__social_fields_data AS n ON l.id = n.uid');
            }
            else
            {
           
            $query->select(
                    $this->getState(
                            "list.select", " a.* ,( " . $distance . " * acos( cos( radians(" . $zip['lat'] . ") ) * cos( radians( a.latitude ) ) * cos( radians( a.longitude ) - radians( " . $zip['lang'] . ") ) + sin( radians( " . $zip['lat'] . ") ) * sin( radians( a.latitude ) ) ) ) AS distance "
                    )
            );
            if ($component == "com_k2") {
                $query->select('k.title as name,k.alias as k2alias,k.catid as k2catid');
            }
            else if ($component == "com_comprofiler") {
                $query->select('l.username as name');
                 $query->select('k.*');
            }
            else if($component=="com_hikamarket")
            {
                 $plugin = JPluginHelper::getPlugin('hikamarket', 'mymaplocations');
                $params = new JRegistry($plugin->params);
                $company=$params->get('vendor_company_column','vendor_address_company');
                $address=$params->get('vendor_address_column','vendor_address_street');
                $city=$params->get('vendor_city_column','vendor_address_city');
                $st=$params->get('vendor_state_column','vendor_address_state');
                $country=$params->get('vendor_country_column','vendor_address_country ');
                $zip=$params->get('vendor_zip_column','vendor_address_post_code');
                $query->select('j.product_id as product_id,r.price_currency_id as currency_id,r.price_value as price_value,n.category_name as category_name ,n.category_id as category_id,j.product_vendor_id as vendor_id,j.product_tax_id as tax_id,k.vendor_name as vendor_name,i.file_path as logo,i.file_path as icon,j.product_name as name,k.'.$company.' as company, k.'.$address.' as address, k.'.$zip.' as postal,k.'.$city.' as town,q.zone_name_english as locationstate,m.zone_name_english as country');  
         
            }
             else if($component=="com_hikashop")
            {
                 $plugin = JPluginHelper::getPlugin('hikamarket', 'mymaplocations');
                $params = new JRegistry($plugin->params);
                $company=$params->get('vendor_company_column','vendor_address_company');
                $address=$params->get('vendor_address_column','vendor_address_street');
                $city=$params->get('vendor_city_column','vendor_address_city');
                $st=$params->get('vendor_state_column','vendor_address_state');
                $country=$params->get('vendor_country_column','vendor_address_country ');
                $zip=$params->get('vendor_zip_column','vendor_address_post_code');
                $query->select('k.vendor_name as name,k.'.$company.' as company, k.'.$address.' as address, k.'.$zip.' as postal,k.'.$city.' as town,q.zone_name_english as locationstate,m.zone_name_english as country,k.vendor_image as icon');  
         
            }

            $query->from('`#__mymaplocations_location` AS a');
            if ($component == "com_k2") {
                $query->join('LEFT', '#__k2_items AS k ON k.id = a.extra_id');
            } 
            
            else if ($component == "com_comprofiler") {
                $query->join('LEFT', '#__comprofiler AS k ON k.id = a.extra_id');
                $query->join('LEFT', '#__users AS l ON l.id = a.extra_id');
                $userlist=JRequest::getInt('cb_list');
                if(!empty($userlist))
                {
                $db = JFactory::getDBO();
                $sql="select * from #__comprofiler_lists where listid=".(int)$userlist;
                $db->setQuery($sql);
                $group = $db->loadObject();
                $ugroup=explode( '|*|',$group->usergroupids);
                   if(!empty($group->filterfields))
                    {
                        $group->filterfields=MyMaplocationsHelper::utf8RawUrlDecode( substr( $group->filterfields, 1 ) );
                        $group->filterfields=str_replace("'cb_","'k'.'cb_",$group->filterfields);
                            $query->where($group->filterfields);
     
                    }
                    if(!empty($ugroup))
                        { 
                    $query->where('g.group_id IN (' . implode( ",",$ugroup) . ')');
                  $query->join('LEFT','#__user_usergroup_map AS g ON g.user_id = a.extra_id');

                }
                }
            }
            else if ($component == "com_hikamarket") {
                $query->join('LEFT', '#__hikamarket_vendor AS k ON k.vendor_id = a.extra_id');
                $query->join('LEFT', '#__hikashop_product AS j ON k.vendor_id = j.product_vendor_id');
                $product_category_id=JRequest::getInt('product_category');
                $searchproduct=JRequest::getVar('searchproduct');
                $query->join('LEFT', '#__hikashop_product_category AS p ON p.product_id = j.product_id');
                $query->join('LEFT', '#__hikashop_file AS i ON i.file_ref_id = j.product_id');
                $query->join('LEFT', '#__hikashop_zone AS q ON q.zone_namekey =k.'.$st);
                $query->join('LEFT', '#__hikashop_zone AS m ON m.zone_namekey =k.'.$country);
                $query->join('LEFT', '#__hikashop_category AS n ON n.category_id =p.category_id');
                $query->join('LEFT', '#__hikashop_price AS r ON r.price_product_id =j.product_id');
            }
            else if ($component == "com_hikashop") {
                $query->join('LEFT', '#__hikamarket_vendor AS k ON k.vendor_id = a.extra_id');
                $query->join('LEFT', '#__hikashop_zone AS q ON q.zone_namekey =k.'.$st);
                $query->join('LEFT', '#__hikashop_zone AS m ON m.zone_namekey =k.'.$country);
            }
            // Filter by published state
            $published = 1;
            $query->where('a.state = ' . (int) $published);
            if (($component == "com_k2")&&(!empty($k2_catid))) {
                require_once JPATH_SITE.'/components/com_k2/models/itemlist.php';
                $K2ModelItemlist = K2Model::getInstance('Itemlist', 'K2Model');
                $finaldata=$K2ModelItemlist->getCategoryTree((int)$k2_catid);
                JArrayHelper::toInteger($finaldata);
                $query->where('k.catid IN('.implode(",", $finaldata).')');
                
            }
            else if (!empty($catid)) {
                $finalcat[]=$catid;
                $categoriesModel = JCategories::getInstance('mymaplocations');
                $category = ($categoriesModel->get($catid));
                $childrens = $category->getChildren(true);
                foreach( $childrens as $children)
                {
                   $finalcat[]=($children->id);
                }
                JArrayHelper::toInteger($finalcat);
                $query->where('a.catid IN('.implode(",", $finalcat).')');
            }
            
            if ($component == "com_k2") {
                $query->where(' a.component = ' . $db->quote($component));
                $query->where(' k.published =1 AND k.trash=0 ');
            } 
            else if ($component == "com_comprofiler") {
                $query->where(' a.component = ' . $db->quote($component));
                $query->where(' k.approved =1 AND k.confirmed=1 ');
            }
            else if ($component == "com_hikamarket") {
               
                $query->where(' a.component = ' . $db->quote($component));
                $query->where(' k.vendor_published =1');
                $query->where(' j.product_published =1');
                  if(!empty($product_category_id))
                  {
                    $query->where('p.category_id ='.$product_category_id);
                  }
                   $query->where('q.zone_namekey =k.'.$st);
                  
                $text = $db->quote('%' . $db->escape($searchproduct, true) . '%', false);
                if(!empty($searchproduct))
                {
                    $wheres2	= array();
		    $wheres2[]	= 'j.product_name LIKE ' . $text;
		    $wheres2[]	= 'k.vendor_name LIKE ' . $text;
                    $where		= '(' . implode(') OR (', $wheres2) . ')';
                    $query->where('('. $where .')');
                
                }
                $query->group($db->quoteName('j.product_id'));
            }
            else {
                if($component=="com_hikashop")
                {
                     $query->where(' k.vendor_published =1');
                    $component="com_hikamarket";
                }
                $query->where(' ( a.component = ' . $db->quote($component) . ' OR a.component=' . $db->quote("") . ') ');
            }
            // Filter by language
            if($component=="com_mymaplocations")
            {
                $query->select('c.access AS category_access')
			->join('LEFT', '#__categories AS c on c.id = a.catid');
		if ($this->getState('filter.language'))
		{
			$query->where('a.language in (' . $db->quote(JFactory::getLanguage()->getTag()) . ',' . $db->quote('*') . ')');
		}
                $query->where( 'c.published=1');
            }
             if($country_list)
                {
                    $query->where('a.country =' . $db->quote($country_list) .'');
                    
                }
                if($state_list)
                {
                    $query->where('a.locationstate =' . $db->quote($state_list) .'');
                    
                }
            }
            
            if (empty($radius)) {
                $radius = explode(',', $params->get('distance'));
                $query->having('distance < ' . (int) $radius[0]);
            }
            //option to add anywhere in the list
            else if ($radius == -1) {
                
            } else {
                $query->having('distance < ' . (int) $radius);
            }

            $query->order('distance');
        }
        //=echo nl2br(str_replace('#__','jos_',$query));die();
        return $query;
    }

    /**
	 * Method to get a list of Locations.
	 * Overridden to add a check for access levels.
	 *
	 * @return  mixed  An array of data items on success, false on failure.
	 *
	 * @since   1.6.1
	 */
	public function getItems()
	{
		$items = parent::getItems();
                $component = $this->getState('filter.component');
		if ((JFactory::getApplication()->isSite())&&($component=="com_mymaplocations"))
		{
			$user = JFactory::getUser();
			$groups = $user->getAuthorisedViewLevels();

			for ($x = 0, $count = count($items); $x < $count; $x++)
			{
				// Check the access level. Remove articles the user shouldn't see
				if (!in_array($items[$x]->category_access, $groups))
				{
					unset($items[$x]);
				}
			}
		}

		return $items;
	}
    public function getCity() {
        $db = JFactory::getDBO();
        $query = "SELECT distinct town,locationstate,country FROM #__mymaplocations_location where state=1 AND town  <>'' ORDER BY country,locationstate";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        return $rows;
    }

}
