<?php

/**
 * @version    2.2.12
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * ****@author      joomunited - contact@joomunited.com
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View class for a list of MyMaplocations.
 */
class MyMaplocationsViewlocations extends JViewLegacy {

    protected $items;
    protected $pagination;
    protected $state;
    protected $params;

    /**
     * Display the view
     */
    public function display($tpl = null) {
        $doc = JFactory::getDocument();
        $doc->addStyleSheet(JURI::base() . 'components/com_mymaplocations/assets/style.css');
        $app = JFactory::getApplication();
        $this->params = JComponentHelper::getParams('com_mymaplocations');
        $active = $app->getMenu()->getActive();
        if ($active) {
            $params = $app->getMenu()->getParams($active->id);
            $this->params->merge($params);
        }
        $bootstrap = $this->params->get('bootstrap', 0);
        if ($bootstrap == 1) {
            $doc->addStyleSheet(JURI::base() . '/media/jui/css/bootstrap.min.css');
        }
        $this->distances = explode(",", $this->params->get('distance', '5,10,15,20'));
        $this->distance_type = $this->params->get('distance_type', 1);
        $this->jq_lib = $this->params->get('jquery', 1);
        $this->zoom = JRequest::getVar('zoom', ($this->params->get('zoom', 11)));
        $this->map = JRequest::getVar('map', $this->params->get('map', 0));
        $this->bingkey = $this->params->get('bingapi');
        $this->component = JRequest::getVar('component', ($this->params->get('component', 'com_mymaplocations')));
        $this->bingkey = $this->params->get('bingapi');
        $this->height = MyMaplocationsHelper::formatField(JRequest::getVar('height', $this->params->get('height', 400)));
        $this->width = MyMaplocationsHelper::formatField(JRequest::getVar('width', $this->params->get('width', '58%')));
        $this->matwidth = MyMaplocationsHelper::formatField(JRequest::getVar('matwidth', $this->params->get('matwidth','40%')));
        $this->matheight = MyMaplocationsHelper::formatField(JRequest::getVar('matheight', $this->params->get('matheight', 400)));
        $this->show_filter = $this->params->get('filter_cat', 0);
        $this->show_country=$this->params->get('filter_country', 0);
        $this->show_anywhere = $this->params->get('anywhere', 1);
        $this->show_anywheredefault = $this->params->get('anywhere_default', 1);
        $this->distance_hide = $this->params->get('distance_hide', 1);
        $this->orcolor = $this->params->get('butoncolor', null);
        $this->globalcolor = $this->params->get('globalcolor', '#2980b9');
        $this->markercolor = $this->params->get('markercolor', '#000000');
        $this->bgimage = $this->params->get('bgimage', null);
        $this->dms = $this->params->get('dms', 1);
        $this->geo = JRequest::getVar('geo');
        $this->cluster = $this->params->get('cluster', 1);
        $this->google_maptype = $this->params->get('google_maptype', 'ROADMAP');
        $this->bing_maptype = $this->params->get('bing_maptype', 'road');
        $this->geocode = 0;
        $this->contactbtn=$this->params->get('contact_button',1);
        $this->target = $this->params->get('target', 3);
        $this->map_design=$this->params->get('map_design', 1);
        $this->autozoom=$this->params->get('autozoom', 1);
        $this->limit=JRequest::getVar('limit',0);
        JRequest::setVar('limit', $this->limit);
        JRequest::setVar('component', $this->component);
        if($this->component=="com_community")
        {
            $lang = JFactory::getLanguage();
            $lang->load( 'com_community.country',JPATH_SITE);
        }
        $this->state = $this->get('State');
        $zipcode = $this->state->get('filter.zip');
        $category = "";
        @$zip = MyMaplocationsHelper::getLatLongFromPostcode($this->state->get('filter.zip'));
        $filter_catid = JRequest::getVar('filter_catid', 0);
         if(!(MyMaplocationsHelper::checkComponent($this->component)))
        {
            
            return;
        }
        //$this->lists['catid'] 	= JHTML::_('list.category',  'filter_catid', 'com_mymaplocations', intval( $filter_catid ));
        if (empty($zip['lat']) && empty($zip['lang'])) {
            if (!empty($zipcode)) {
                JFactory::getApplication()->enqueueMessage(JTEXT::_('COM_MYMAPLOCATIONS_ERROR_GEOCODE'));
            }
            $this->items = array();
        }
        
        else if(empty($zipcode))
        {
            $this->items = array();    
        }
        else {
            $this->items = $this->get('Items');
            $this->pagination = $this->get('Pagination');
        }
        $this->cities = $this->get('city');
        // Check for errors.
        if (count($errors = $this->get('Errors'))) {
            JError::raiseError(500, implode("\n", $errors));
            return false;
        }
        if (empty($this->geo)) {
            $this->geocode = $this->params->get('geo', 0);
            ;
        }
        if ($this->show_filter == 1) {
            $options = array_merge(
                    array('' => JText::_('JOPTION_SELECT_CATEGORY')), JHtml::_('category.options', 'com_mymaplocations',$config = array('filter.published' => array(1)))     );
            $this->category = JHTML::_('select.genericlist', $options, 'filter_catid', null, 'value', 'text', $filter_catid);
            if($this->component=="com_k2")
            {
                $this->k2catid=JRequest::getInt('k2_catid',0);
		require_once JPATH_ADMINISTRATOR.'/components/com_k2/models/categories.php';
		$categoriesModel = K2Model::getInstance('Categories', 'K2Model');
		$categories = array_merge(
                    array('' => JText::_('JOPTION_SELECT_CATEGORY')), $categoriesModel->categoriesTree()
                );
                $this->k2category=JHTML::_('select.genericlist', $categories, 'k2_catid', 'class="inputbox"', 'value', 'text', $this->k2catid);
            }
            else if($this->component=="com_hikamarket")
            {
                $this->hikacategory="<div class='adv-search'>".MyMaplocationsHelper::getHikaCategory()."</div>";
              
               
            }
        }
        $this->zip=$zip;
        $this->_prepareDocument();
        parent::display($tpl);
    }

    /**
     * Prepares the document
     */
    protected function _prepareDocument() {
        $app = JFactory::getApplication();
        $menus = $app->getMenu();
        $title = null;

        // Because the application sets a default page title,
        // we need to get it from the menu item itself
        $menu = $menus->getActive();
        if ($menu) {
            $this->params->def('page_heading', $this->params->get('page_title', $menu->title));
        } else {
            $this->params->def('page_heading', '');
        }
        $title = $this->params->get('page_title', '');
        if (empty($title)) {
            $title = $app->getCfg('sitename');
        } elseif ($app->getCfg('sitename_pagetitles', 0) == 1) {
            $title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
        } elseif ($app->getCfg('sitename_pagetitles', 0) == 2) {
            $title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
        }
        $this->document->setTitle($title);

        if ($this->params->get('menu-meta_description')) {
            $this->document->setDescription($this->params->get('menu-meta_description'));
        }

        if ($this->params->get('menu-meta_keywords')) {
            $this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
        }

        if ($this->params->get('robots')) {
            $this->document->setMetadata('robots', $this->params->get('robots'));
        }
    }

}
